#!/bin/bash

# Create the jailkit chroot 

#
# Usage: ./create_jailkit_chroot username 'basicshell editors'
#


# Sanity check

if [ "$1" = "" ]; then
        echo "    Usage: ./create_jailkit_chroot username 'basicshell editors'"
        exit
fi

CHROOT_HOMEDIR=$1
CHROOT_APP_SECTIONS=$2

## Change ownership of the chroot directory to root
chown root:root $CHROOT_HOMEDIR

## Initialize the chroot into the specified directory with the specified applications
jk_init -f -k -j $CHROOT_HOMEDIR $CHROOT_APP_SECTIONS

## Create the temp directory
if [ ! -d "$CHROOT_HOMEDIR/tmp" ]
then
  mkdir $CHROOT_HOMEDIR/tmp
fi
chmod a+rwx $CHROOT_HOMEDIR/tmp

# mysql needs the socket in the chrooted environment
	/./usr/local/ispconfig/server/scripts/jailkit_mysql_sock_fix.sh -fixMySqlSock $CHROOT_HOMEDIR
