#!/bin/bash
###############################################################################################
# Usage: 
# "./jailkit_mysql_sock_fix.sh 	mountAll" or umountAll"
#								-rmCHROOT /var/www/clients/clientXYZ/webXYZ" to delete jail, becose it must be umounted before delete.
# 								-fixMySqlSock /var/www/clients/clientXYZ/webXYZ" to fix it by existing CHROOTs, which created before this skript used.
#								-fixAll" ^-but for all existing CHROOTs 
#								-rmCHROOT /var/www/clients/clientXYZ/webXYZ" to remove CHROOT
#								-updateAll '/bin/mySoft /bin/myOtherSoft /x/y/*'" list of new Apps 
#
# IMPORTANT::: CHECK "Costomize" if ISPCONFIG3 or Services or SETTINGS are different from defaults 
###
# Costomize only if "System" -> "Server Config" -> "Web" -> "Website path" in ISPc-UI modified.
jails="/var/www/clients/client*/web*/bin" #finds all ISPCONFIGs CHROOTs !-> some Jailkits file schould be includet in String, for example "*/bin"!!! 
###
# Costomize only if "my.ini" -> "[mysqld*]" -> "socket" modified.
mysqlSOCK="/var/run/mysqld/mysqld.sock"
###
###############################################################################################
###############################################################################################
iter=0
for jail in ${jails[@]}
do
	if [ -e "$jail" ] 
	then
		jails[$iter]=${jail//"/bin"/""}
	else
		jails=""
	fi
	iter=$((iter+1))
done
####
args=$@
###
################# FUNCTIONS #################
#
###############################
# mountAll (){
#*****	Version:        beta
#*****  Date:           15.08.2011
#*****  toDo:
###############################
function mountAll () {
case "${1:-''}" in
#
  'mountAll')
		if [ -e "$mysqlSOCK" ]
		then  	
        for jail in ${jails[@]}
        do
        	mount --bind $mysqlSOCK $jail"$mysqlSOCK"
        done
        exit 0
		#else
		#	sleep 2
		#	mountAll "mountAll"
		fi
        ;;
#
  'umountAll')
        for jail in ${jails[@]}
        do
        umount $jail"$mysqlSOCK"
        done
        exit 0
        ;;
#
  *)
        echo "${1:-''} is no action!!!  Usage: mountAll | umountAll"
        exit 1
        ;;
#
	'-fixAll')
		for jail in ${jails[@]}
        do
			[ -a "$jail/var" ] || mkdir $jail/var
			[ -a "$jail/var/run" ] || mkdir $jail/var/run
			[ -a "$jail/var/run/mysqld" ] || mkdir $jail/var/run/mysqld
					
			if [ -e "$jail$mysqlSOCK" ]
			then
				rm $jail$mysqlSOCK
				touch $jail$mysqlSOCK
			else
				touch $jail$mysqlSOCK
			fi
			
			if [ -e "$mysqlSOCK" ] 
        	then
        		mount --bind $mysqlSOCK $jail$mysqlSOCK
        	fi
		done	
	;;

#
esac
}
###############################
# JailKitMods (){
#*****	Version:	beta
#*****	Date:		15.08.2011
#*****	toDo:
###############################
function JailKitMods () {
args=$@
# $@ -to-> array
argsNR=0;
for i in $args ; do
        arguments[$argsNR]=$i
        argsNR=$((argsNR+1))
done
# array -to-> variable
argsNR=0
while [ "$argsNR" -lt "$#" ]
do
        case ${arguments[argsNR]} in
#
	'-rmCHROOT')
		if [ -e ${arguments[$((argsNR+1))]} ]
		then
			umount ${arguments[$((argsNR+1))]}"$mysqlSOCK"
			toRM=${arguments[$((argsNR+1))]}
			rm -R $toRM"/bin" $toRM"/dev" $toRM"/etc" $toRM"/home" $toRM"/lib" $toRM"/usr" $toRM"/var" $toRM"/.bash_history"
		else
			echo "[warn]: ${arguments[$((argsNR+1))]} not exists!!! <aborting operation>"
			exit 1
		fi
	;;
# example: -fixMySqlSock /path/to/jailad/root
	'-fixMySqlSock')
		if [ -d ${arguments[$((argsNR+1))]} ]
		then
			toMake=${arguments[$((argsNR+1))]}
			
			[ -a "$toMake/var" ] || mkdir $toMake/var
			[ -a "$toMake/var/run" ] || mkdir $toMake/var/run
			[ -a "$toMake/var/run/mysqld" ] || mkdir $toMake/var/run/mysqld
					
			if [ -e "$toMake$mysqlSOCK" ]
			then
				rm $toMake$mysqlSOCK
				touch $toMake$mysqlSOCK
			else
				touch $toMake$mysqlSOCK
			fi
			
			if [ -e "$mysqlSOCK" ] 
        	then
        		mount --bind $mysqlSOCK $toMake$mysqlSOCK
        	fi
			
		else
			echo "[error]: DIR: \"${arguments[$((argsNR+1))]}\" not exists!!! <aborting operation>"
			exit 1
		fi
	;;
# z.B wenn ISPCONFIG3-Admin etvas zu "Jailkit * chrooted applications" hinzufuegt
	'-updateAll')
		if [ -e ${jails[0]} ]
		then
			for jail in ${jails[@]}
			do
				jk_cp -k $jail ${arguments[$((argsNR+1))]}
			done
		fi
	;;

	* )
		echo "[error]: ${arguments[argsNR]} is no Option!!! Usage: -rmCHROOT /path/to/jailCHROOTroot|"
	;;
#
	esac
	argsNR=$((argsNR+2))
done
}
#
#
####################################################################################
################# ACTION ############# ACTION ############# ACTION #################
####################################################################################
if [ "$#" -eq 1 ]
then
	mountAll $@
elif [ "$(($# % 2))" -eq 0 ]
then
	#modus="JailKitMods"
	JailKitMods $@
elif [ "$(($# % 3))" -eq 0 ]
then
	modus="func with * 3 Params"
fi
###############################################################################################
# Autor Rafael.K
#*****
#*****
#*****
###############################################################################################
